
<template>
  <q-page class="flex">
    <div class="doc-container col-12">
      <div class="minheight-rows gutter-xs">
        <div class="row title-row items-center">
          <i class="far fa-user"></i>
          <div class="page-title">{{ $t('user.list') }}</div>
        </div>
        <div class="row justify-start">
          <div class="col-6">
            <q-field
                icon="search"
                error-label="Some error"
            >

              <q-input
                v-model="searchedUser"
                :float-label="$t('user.search')"
              />
            </q-field>
          </div>
          <div class="col-6">
            <div class="row justify-end items-center">
              <q-btn
                icon="add"
                :label="$t('user.add')"
                @click="add"
                class="action-btn"
                rounded
              />
            </div>
          </div>
        </div>

        <div class="row justify-start">
          <q-card inline
                  class="user"
                  v-for="(user, index) in filteredItems"
                  :key="index"
                  :class="user.admin ? 'admin' : ''"
          >
            <q-card-media>
              <img :src="user.admin ? getImg('card.admin') : getImg('card.user')">
            </q-card-media>
            <q-item>
              <q-item-main>
                <q-item-tile label><strong>{{ user.name }}</strong></q-item-tile>
              </q-item-main>
              <q-item-side :avatar="user.admin ? getImg('admin') : getImg('user')"
                           class="avatar"

              />
            </q-item>
            <q-card-main>
              <span>
                {{ $t('user.name') }} : {{ user.username }}
            </span>
            </q-card-main>
            <q-card-actions class="q-pb-md q-pl-md">
              <q-btn outline rounded
                       class="action-btn"
                       @click="edit(user)"
                >{{ $t('Edit') }}</q-btn>
              <q-btn outline rounded :disable="user.username === 'admin'"
                       class="action-btn"
                       @click="deleteUser(user)"
                >{{ $t('Delete') }}</q-btn>
            </q-card-actions>
          </q-card>
        </div>

        <q-modal v-model="layoutModal"
                 class="user"
                 :content-css="{minWidth: '40vw', minHeight: '80vh'}"
        >
          <q-modal-layout>
            <q-toolbar slot="footer" class="justify-end" inverted>
              <div class="col-3">
                <q-btn :label="$t('Cancel')"
                       @click="closeModal"
                       flat
                       rounded
                       class="full-width"
                />
              </div>
              <div class="col-5">
                <q-btn :label="$t('Save')"
                       @click="save"
                       outline
                       rounded
                       class="action-btn full-width"
                       v-if="this.isEditing"
                />
                <q-btn :label="$t('user.add')"
                       @click="save"
                       outline
                       rounded
                       class="action-btn full-width"
                       v-else
                />
              </div>
            </q-toolbar>

            <div class="layout-padding">
              <div class="row title-row items-center margin-bottom-20">
                <i class="fas fa-user-plus"></i>
                <div v-if="this.isEditing" class="page-title">{{ $t('Editing') }} {{username}}</div>
                <div class="page-title" v-else>{{ $t('user.adding') }}</div>
              </div>
              <div class="row">
                <div class="col-12">
                  <q-field :helper="$t('user.helper')">
                    <q-input
                      v-model="username"
                      max-length="50"
                      :error-label="$t('user.helper_error')"
                      :error="$v.username.$error"
                      @blur="$v.username.$touch"
                      :float-label="$t('user.name')"
                      :disabled="isEditing"
                      :readonly="isEditing"
                    />
                  </q-field>
                  <q-field>
                    <q-input v-model="name"
                             max-length="250"
                             :float-label="$t('Name')"
                             :disabled="isEditing && provider!=null && provider != ''"
                             :readonly="isEditing && provider!=null && provider != ''"
                    />
                  </q-field>
                  <q-field>
                    <q-input type="password"
                             v-model="password"
                             max-length="50"
                             :float-label="$t('Password')"
                             v-if="!provider"
                    />
                  </q-field>
                  <q-field>
                    <q-checkbox v-model="admin" :label="$t('user.Admin')" left-label/>
                  </q-field>
                </div>
              </div>
            </div>

          </q-modal-layout>
        </q-modal>
      </div>
    </div>

  </q-page>
</template>

<script>
import {mapActions, mapState} from 'vuex'
import { required, helpers } from 'vuelidate/lib/validators'

const usernameValidator = helpers.regex('username', /^[a-zA-Z0-9.-]*$/)

export default {
  name: 'Users',
  data: () => ({
    name: '',
    username: '',
    provider: '',
    admin: false,
    isEditing: false,
    password: '',
    searchedUser: '',
    search: '',
    layoutModal: false
  }),
  methods: {
    ...mapActions('users', ['listUsers', 'saveUser', 'deleteUser']),
    cleanModal: function () {
      this.isEditing = false
      this.name = ''
      this.username = ''
      this.password = ''
      this.admin = false
    },
    add: function () {
      this.cleanModal()
      this.layoutModal = true
    },
    edit: function (user) {
      this.name = user.name
      this.username = user.username
      this.provider = user.provider
      this.admin = !!user.admin
      this.isEditing = true
      this.layoutModal = true
    },
    closeModal: function () {
      this.layoutModal = false
      this.cleanModal()
    },
    save: function () {
      if (this.$v.$invalid) {
        return
      }
      this.saveUser({
        name: this.name,
        username: this.username,
        admin: this.admin,
        password: this.password
      })
      this.closeModal()
    },
    getImg: function (url) {
      var images = require.context('../../assets/', false, /\.png$/)
      return images('./' + url + '.png')
    }
  },
  validations: {
    username: { required, usernameValidator }
  },
  computed: {
    filteredItems: function () {
      if (!this.searchedUser) {
        return this.users
      }
      return this.users.filter(user => user.name.toLowerCase().includes(this.searchedUser.toLowerCase()) ||
              user.username.toLowerCase().includes(this.searchedUser.toLowerCase()))
    },
    ...mapState('users', {users: (state) => state.users})
  },
  mounted: function () {
    this.listUsers()
  }
}
</script>
